function v=apm(M)
% find ALL principal minors of a matrix

% consider each principal submatrix
  n=size(M,1);
  for i=1:(2^n)-1
      A=M;
      s=n;
      j=uint32(i);

%     delete the rows and columns specified by the bit pattern
      for k=1:n
          p=bitget(j,1);
          if(p == 0)
%            decrement the size of the submatrix
             s=s-1;

%            delete row n-k+1 by copying rows up
             for r=n-k+1:s
                 A(r,[1:n])=A(r+1,[1:n]);
             end
%            and zeroing out the bottom nonzero row
             A(s+1,[1:n])=0;

%            delete column n-k+1 by copying columns left
             for c=n-k+1:s
                 A([1:n],c)=A([1:n],c+1);
             end
%            and zeroing out the rightmost nonzero column
             A([1:n],s+1)=0;
          end
          j=bitshift(j,-1);
      end

%     the minor is the determinant of the submatrix
      v(i)=det(A([1:s],[1:s]));
  end
end
