function [xstar,lambda,kl,rc,mu]=auglag(name,meq,xzero,epz,kmax)
% solve an equality-constrained nonlinear program by augmented Lagrangian

  global prob m mu lambda  % to aug.m, augg.m, and augh.m
  prob=name;               % pass the problem name
  m=meq;                   % the number of equality constraints
  mu=1;                    % the initial value of mu
  lambda=zeros(1,m);       % and the initial value of lambda
  fcn=str2func(prob);      % get a pointer to the function routine
  xstar=xzero;             % start at the starting point
  rc=1;                    % default rc to indicate nonconvergence

  for kl=1:kmax
%     minimize the penalty function
      [xnew,kn,nm]=ntrs(xstar,0,kmax,epz,@aug,@augg,@augh,0.5);
      for kx=1:10
          if(nm > 0)
             mu=2*mu;
             [xnew,kn,nm]=ntrs(xstar,0,kmax,epz,@aug,@augg,@augh,0.5);
          else
             break
          end
      end
      xstar=xnew;

%     update the multipliers
      esq=0;
      for i=1:m
          delta=2*mu*fcn(xstar,i);
          lambda(i)=lambda(i)+delta;
          esq=esq+delta^2;
      end

%     test convergence
      if(sqrt(esq) <= epz)
         rc=0;
         return
      end
  end
end
