% Broyden-Fletcher-Goldfarb-Shanno taking a full step if possible
function [xstar,Gstar,kp,rc]=bfgsfs(xzero,Gzero,xl,xh,kmax,epz,fcn,grd)
n=size(xzero,1);
mu=0.0001;
eta=0.9;
tol=0.01;
smax=52;
xk=xzero;
g=grd(xk);
G=Gzero;
for kp=1:kmax
    dk=G*(-g);
    [rcchk]=chkwlf(xk,dk,1,mu,eta,fcn,grd);  % is a full step OK?
    if(rcchk == 0)                           % if so,
       astar=1;                              % use it
       rc=8;                                 % and tell the caller
    else
      [astar,rc]=wolfe(xk,dk,xl,xh,n,fcn,grd,mu,eta,tol,smax);
      if(rc > 2) break; end
    end
    sk=astar*dk;
    xk=xk+sk;
    gnew=grd(xk);
    yk=gnew-g;
    g=gnew;
    if(norm(g) <= epz) break; end
    rho=1/(yk'*sk);
    G=(eye(n)-rho*sk*yk')*G* ...
      (eye(n)-rho*yk*sk')+rho*sk*sk';
end
xstar=xk;
Gstar=G;
