function x=big(a,x,cmax,smax)
% solve the big problem using cyclic coordinate descent

n=size(x,1);                         % get number of variables
for c=1:cmax                         % do cmax cycles
    for j=1:n                        % in each coordinate direction
        al=0; ah=1;                  % search for alpha in [0,1]
        xl=min(a(j),1/a(j));         % which keeps x between xl
        xh=max(a(j),1/a(j));         % and xh
        alpha=(x(j)-xl)/(xh-xl);     % alpha at start for cycle c
        for s=1:smax                 % do bisections
            fp=2*a(j)*(x(j)-1);      % directional derivative
            if(fp < 0)               % is min to the right?
               al=alpha;             % if so increase lower bound
            else                     % no; min is to the left
               ah=alpha;             % decrease upper bound
            end
            alpha=(al+ah)/2;         % bisect interval in alpha
            x(j)=xl+alpha*(xh-xl);   % find corresponding x(j)
        end                          % bisections done
    end                              % coordinates done
end                                  % cycles done
