% brewip.m: solve integer brewery problem by exhaustive enumeration

A=[7,10,8,12;
   1, 3,1, 1;
   2, 4,1, 3];
b=[160;50;60];
c=[-90;-150;-60;-70];

% find the maximum possible value of each variable
for j=1:4
    xmax(j)=intmax;
    for i=1:3
        xmax(j)=min(xmax(j),fix(b(i)/A(i,j)));
    end
end

% examine all integer points that might be feasible
zstar=0;
for x1=0:xmax(1)
    for x2=0:xmax(2)
        for x3=0:xmax(3)
            for x4=0:xmax(4)
                x=[x1;x2;x3;x4];

%               is the point feasible?
                s=b-A*x;
                if(min(s) < 0)
                   continue
                end
%
%               yes; update the optimal point
                z=c'*x;
                if(z < zstar)
                   zstar=z;
                   xstar=x;
                   continue
                end

            end
        end
    end
end

xstar
zstar
