function [xstar,kp,beta]=cg(xzero,kmax,epz,Q,b)
% minimize 1/2 x'Qx - b'x by conjugate gradients
  xk=xzero;
  rk=Q*xk-b;
  d=-rk;
  for kp=1:kmax
      if(norm(rk) <= epz)
         xstar=xk
         return
      end
      alpha=(rk'*rk)/(d'*Q*d);
      xk=xk+alpha*d;
      rkp=rk+alpha*Q*d;
      beta=(rkp'*rkp)/(rk'*rk);
      d=-rkp+beta*d;
      rk=rkp;
  end
  xstar=xk;
end
