function [rc]=chkwlf(xk,dk,alpha,mu,eta,fcn,grd)
% check the Wolfe conditions
  gk=grd(xk);                 % gradient at current point
  dfk=gk'*dk;                 % directional derivative there
  fk=fcn(xk);                 % function value at current point
  x=xk+alpha*dk;              % proposed next point
  g=grd(x);                   % gradient there
  df=g'*dk;                   % directional derivative there
  f=fcn(x);                   % function value there
  rc=0;                       % assume both conditions satisfied
  if(f > fk+mu*dfk*alpha)     % sufficient decrease?
     rc=rc+1;                 % no; violated
  end
  if(abs(df) > eta*abs(dfk))  % curvature?
     rc=rc+2;                 % no; violated
  end
end
