% convcheck.m: search for a point where H(x) is not positive definite
function [flag,xbad]=convcheck(n,xl,xh,hsn)

x=zeros(n,1);                          % make x a column vector
xbad=x;                                % return xbad=0 if none found
flag=+1;                               % assume positive definite
for k=1:10^(n+1)                       % inspect many points
    u=rand(n,1);                       % generate a random n-vector
    for j=1:n                          % select
        x(j)=xl(j)+u(j)*(xh(j)-xl(j)); % a random point
    end                                % within the bounds
    H=hsn(x);                          % find the Hessian there
    ev=eig(H);                         % find its eigenvalues
    for j=1:n                          % check them all
        if(abs(ev(j)) < 1e-8)          % if small assume zero
          flag=0;                      % which makes H psd
          xbad=x;                      % at this x
        end
        if(ev(j) < 1e-8)               % if negative
          flag=-1;                     % that makes H not psd
          xbad=x;                      % at this x
          return                       % and we are done
        end
    end
end
