function converge(r,c,ezero,kmax)
% plot a given arbitrary set of ideal error curves
  if(r == 1)                   % find ending error
     form=ezero*c^kmax         % from the formulas we derived
  else
     form=ezero^(r^kmax)*c^((1-r^kmax)/(1-r))
  end

  ek=ezero                     % current error = starting error
  kk(1)=0;                     % at zero iterations
  err(1)=ek/ezero;             % starting relative error = 1
  for k=2:kmax+1               % plot for k=0...kmax
      ek=c*ek^r                % recursion for next error
      if(ek == 0) break; end   % if zero no point in more
      err(k)=ek/ezero;         % current relative error
      kk(k)=k-1;               % at current iteration
  end
  semilogy(kk,err)             % plot the iterated error curve
end
