% cubslv.m: find the stationary points of arch1
% a graph shows where the roots are approximately
set(gca,'FontSize',35)
for p=1:100
    x1(p)=4*(p-1)/99;
    y(1,p)=4*x1(p)^3-24*x1(p)^2+38*x1(p)-10;
    y(2,p)=0;
end
plot(x1,y)
print -deps -solid cubslv.eps
xzeros=[0,1;2,3;3,4];

% then we can find them precisely
printf('     x1       x2       f0          g        h\n')
for r=1:3
    xzero=xzeros(r,:);
    x1=fzero(@(x1)4*x1^3-24*x1^2+38*x1-10,xzero);
    x2=4*x1-x1^2;
    f=(x1-1)^2+(x2-1)^2;
    g=4*x1^3-24*x1^2+38*x1-10;
    h=12*x1^2-48*x1+38;
    printf('%7.5f  %7.5f  %7.4f  %7.7f  %7.3f\n',x1,x2,f,abs(g),h)
end
