% eacpu.m: plot LRCSE versus CPU for the ellipsoid algorithm when it is used to solve ek1
clear;
talg=0;

[t1,u1,s1]=cputime();
xk=[18;21];
Qk=[80,0;0,169];
n=2;
m=3;
[t2,u2,s2]=cputime();

talg=talg+(u2-u1);
fstar=614.21209720340380;
lambda=[250.99653438461144;0;0];
erz=cse(xk,fstar,lambda,@ek1);
ke=1;
err(ke)=1;
eff(ke)=talg;

for k=1:300
    [t1,u1,s1]=cputime();
    [xk,rc,kused,Qk]=ea(xk,Qk,m,1,0,@ek1,@ek1g);
    [t2,u2,s2]=cputime();

    talg=talg+(u2-u1);
    printf('%3i %f\n',k,talg)
    if(rc > 1) break; end
    ke=ke+1;
    eff(ke)=talg;
    err(ke)=err(ke-1);
    ke=ke+1;
    eff(ke)=talg;
    err(ke)=cse(xk,fstar,lambda,@ek1)/erz;
end

semilogy(eff,err)
