% eaefe.m: plot LRCSE versus EFE for the ellipsoid algorithm when it is used to solve ek1
clear; clf
global NFE=0 NGE=0

xk=[18;21];
Qk=[80,0;0,169];
n=2;
m=3;

fstar=614.21209720340380;
lambda=[250.99653438461144;0;0];
erz=cse(xk,fstar,lambda,@ek1);
ke=1;
err(ke)=1;
eff(ke)=0;

for k=1:300
    [xk,rc,kused,Qk]=ea(xk,Qk,m,1,0,@ek1efe,@ek1gefe);
    if(rc > 1) break; end

    EFE=NFE+n*NGE;
    ke=ke+1;
    eff(ke)=EFE;
    err(ke)=err(ke-1);
    ke=ke+1;
    eff(ke)=EFE;
    err(ke)=cse(xk,fstar,lambda,@ek1)/erz;
end
rc
k

figure(1)
set(gca,'FontSize',25)
semilogy(eff,err)
print -deps -solid eaefe.eps
figure(2)
hold on
set(gca,'FontSize',25)
axis([100,230,1e-5,1e-2])
semilogy(eff(45:120),err(45:120))
hold off
print -deps -solid blowup.eps
