% easy.m: solve gns exactly in only n=2 steps

% data for the gns problem
Q=[8,4;4,4];  % matrix of the quadratic form in x-space
b=[3;0];      % linear-term coefficients in x-space
x=[2;2];      % starting point xzero

% conjugate directions
s1=[1;0];     % arbitrary first conjugate direction
s2=[1/2;-1];  % second direction chosen Q-conjugate to s1

% minimize f(w) in the coordinate directions w1 and w2
S=[s1,s2];    % diagonalizing matrix
Delta=S'*Q*S; % matrix of objective quadratic form in w-space
a=S'*b;       % linear-term objective coefficients in w-space
w=inv(S)*x;                              % map xzero to w-space
d1=[1;0];                                % w1 coordinate direction
alphaw1=-(Delta*w-a)'*d1/(d1'*Delta*d1); % exact line search step
w=w+alphaw1*d1;                          % take step in w1-direction
d2=[0;1];                                % w2 coordinate direction
alphaw2=-(Delta*w-a)'*d2/(d2'*Delta*d2); % exact line search step
w=w+alphaw2*d2;                          % take step in w2-direction
xwstar=S*w                               % map result back to x-space

% minimize f(x) in the conjugate directions s1 and s2
x=[2;2];                                 % starting point
alphax1=-(Q*x-b)'*s1/(s1'*Q*s1);         % exact line search step
x=x+alphax1*s1;                          % step in s1-direction
alphax2=-(Q*x-b)'*s2/(s2'*Q*s2);         % exact line search step
xsstar=x+alphax2*s2                      % step in s2-direction
