function [xt,yt,rc,tmax]=ellipse(xz,yz,Q,smax)
% plot the ellipse (x-xz)'Q(x-xz)=1

  tmax=4*(1+smax)+1;                 % points to be returned
  xt=zeros(tmax,1);                  % fix sizes
  yt=zeros(tmax,1);                  % of coordinate vectors
  detQ=Q(1,1)*Q(2,2)-Q(2,1)*Q(1,2);  % determinant of Q
  if(Q(1,1) <= 0 || detQ <= 0)       % test leading principal minors
     rc=1;                           % not pd => not an ellipse
     return                          % give up
  end
  a=Q(1,1); b=Q(1,2);                % extract
  c=Q(2,1); d=Q(2,2);                % its elements
  t=0;                               % initialize point count

% first quadrant
  t=t+1;                             % count the point
  xt(t)=xz+1/sqrt(a);                % x at theta=0
  yt(t)=yz;                          % y at theta=0
  for s=1:smax                       % find smax interior points
      theta=(pi/2)*(s/(smax+1));                  % angle
      denom=a+(c+b)*tan(theta)+d*(tan(theta))^2;  % denominator
      t=t+1;                                      % count the point
      xt(t)=xz+1/sqrt(denom);                     % x at theta
      yt(t)=yz+(xt(t)-xz)*tan(theta);             % y at theta
  end                                % end of quadrant

% second quadrant
  t=t+1;
  xt(t)=xz;
  yt(t)=yz+1/sqrt(d);
  for s=1:smax
      theta=(pi/2)+(pi/2)*(s/(smax+1));
      denom=a+(c+b)*tan(theta)+d*(tan(theta))^2;
      t=t+1;
      xt(t)=xz-1/sqrt(denom);
      yt(t)=yz+(xt(t)-xz)*tan(theta);
  end

% third quadrant
  t=t+1;
  xt(t)=xz-1/sqrt(a);
  yt(t)=yz;
  for s=1:smax
      theta=pi+(pi/2)*(s/(smax+1));
      denom=a+(c+b)*tan(theta)+d*(tan(theta))^2;
      t=t+1;
      xt(t)=xz-1/sqrt(denom);
      yt(t)=yz+(xt(t)-xz)*tan(theta);
  end

% fourth quadrant
  t=t+1;
  xt(t)=xz;
  yt(t)=yz-1/sqrt(d);
  for s=1:smax
      theta=(3*pi/2)+(pi/2)*(s/(smax+1));
      denom=a+(c+b)*tan(theta)+d*(tan(theta))^2;
      t=t+1;
      xt(t)=xz+1/sqrt(denom);
      yt(t)=yz+(xt(t)-xz)*tan(theta);
  end

% close the ellipse
  t=t+1;
  xt(t)=xz+1/sqrt(a);
  yt(t)=yz;
  rc=0;

end
