function row=fathoma(A,b,x)
% return index of first constraint in Ax <= b violated by all completions

  m=size(A,1);          % find out how many rows are in A and b
  row=0;                % assume no such constraint will be found
  ip=(x' ==  1);        % indices in partial solution where x(j)=1
  ic=(x' == -1);        % indices in trial solution to be completed
  for i=1:m             % check the constraints one at a time
      ap=sum(A(i,ip));  % value of the partial solution
      im=(A(i,:) < 0);  % indices where coefficient A(i,j)<0
      id=bitand(ic,im);          % indices in completion where A(i,j)<0
      ac=sum(A(i,logical(id)));  % value of most negative completion
      ax=ap+ac;                  % value of constraint
      if(ax > b(i));             % if inequality is violated
         row=i;         % get the number of the offending row
         return         % and return it
      end
  end
end
