function [xzero,rc]=feas(A,b)
% find a point that satisfies Ax <= b

  m=size(A,1);                                   % constraints
  n=size(A,2);                                   % variables
  nc=1+n+1+m;                                    % columns
  T=[zeros(1,nc);b,A,-A*ones(n,1),eye(m)];       % form tableau
  mr=1+m;                                        % rows
  tr=[1:mr];                                     % row indices
 [T0,S0,trnew,mrnew,rc0]=newseq(T,mr,nc,tr,mr);  % move basis left
  if(rc0 ~= 0)                                   % infeasible 1?
     rc=1;                                       % signal failure
     return                                      % and give up
  end
 [T1,S1,rc1]=phase1(T0,S0,mrnew,nc,trnew,mrnew); % find feasible
  if(rc1 ~= 0)                                   % infeasible 2?
     rc=2;                                       % signal failure
     return                                      % and give up
  end
  t=0;                                           % zero if nonbasic
  if(S1(n+1) ~= 0) t=T1(S1(n+1),1); end          % this if basic
  xzero=-t*ones(n,1);                            % x=-te
  for j=1:n                                      % decision vars
      if(S1(j) ~= 0)                             % basic?
         xzero(j)=xzero(j)+T1(S1(j),1);          % x=-te+u
      end
  end
  rc=0;                                          % signal success

end
