% first.m: approximate f' for f(x)=exp(x)
clear;clf;set(gca,'FontSize',25)
delta=1.25;
for i=1:100
    delta=0.8*delta;
    deltai(i)=delta;
    dyfe=0;
    dyce=0;

%   first derivative of e^x
    for j=1:101
        x=.01*(j-1);
        y=exp(x);
        xpd=x+delta;
        ypd=exp(xpd);
        xmd=x-delta;
        ymd=exp(xmd);





%       forward differencing
        dyf=(ypd-y)/delta;
        dyfe=dyfe+(dyf-exp(x))^2;

%       central differencing
        dyc=(ypd-ymd)/(2*delta);
        dyce=dyce+(dyc-exp(x))^2;
    end

%   find the norm of each set of errors
    ndyfe(i)=sqrt(dyfe);
    ndyce(i)=sqrt(dyce);
end

% plot the errors
hold on
axis('square')
loglog(deltai,ndyfe)
loglog(deltai,ndyce)
hold off
print -deps -solid first.eps
