function [lambda,rc]=getlgm(m,Abar,W,g)
% compute Lagrange multipliers

  lambda=zeros(m,1);           % zero out multipliers
  [U,rc]=hfact(Abar*Abar',1);  % factor and set return code
  if(rc ~= 0) return; end      % give up if factoring failed
  Vt=Abar'/U;                  % solve
  Aplus=(Vt/U')';              % for pseudoinverse
  ibar=0;                      % need to index rows of Abar
  for i=1:m                    % fill in nonzero multipliers
      if(W(i) == 1)            % is this constraint tight?
         ibar=ibar+1;                 % next row
         lambda(i)=-Aplus(ibar,:)*g;  % use formula
      end                             % done with constraint
  end                          % done with multipliers

end
