function [reldif,mxdiff,mxdifx]=gradtest(fcn,grd,xl,xh,ii)
% compare analytic to finite-difference gradient for function ii

  n=size(xh,1);                    % number of variables
  x=zeros(n,1);                    % x is a column
  mxdiff=0;                        % no maximum difference yet
  for k=1:100                      % try 100 points in [xl,xh]
      for j=1:n                              % with
          x(j)=xl(j)+rand()*(xh(j)-xl(j));   % random
      end                                    % components

      ga=grd(x,ii);                % analytic gradient
      gf=gradcd(fcn,x,ii);         % finite difference gradient
      for j=1:n                    % compare each component
          diff=abs(ga(j)-gf(j));   % difference between components
          if(diff > mxdiff)        % keep track of the
             mxdiff=diff;          % biggest difference
             mxdifx=x;             % and where it occurred
          end                      % done with comparison
      end                          % done with components
  end                              % done with trial points

  nrm=norm(gradcd(fcn,mxdifx,ii)); % size of approximate gradient
  if(nrm < 1e-6)                   % if it is tiny
     reldif=-1;                    % relative error is meaningless
  else                             % norm is not tiny
     reldif=mxdiff/nrm;            % relative error is usefull
  end

end
