function [xc,yc,zc,zmin,zmax]=gridcntr(fcn,xl,xh,ng)
% evaluate fcn(x) at grid points equally spaced in [xl,xh]
  zmax=-realmax;
  zmin=+realmax;
  for i=1:ng
      xc(i)=xl(1)+(xh(1)-xl(1))*((i-1)/(ng-1));
      for j=1:ng
          yc(j)=xl(2)+(xh(2)-xl(2))*((j-1)/(ng-1));
          x=[xc(i);yc(j)];
          zc(j,i)=fcn(x);
          zmax=max(zmax,zc(j,i));
          zmin=min(zmin,zc(j,i));
      end
  end
end
