% compute a Hessian of h35
function h=h35h(x)
  c=[1.5;2.25;2.625];
  h=[0,0;
     0,0];
  for t=1:3
      v=c(t)-x(1)*(1-x(2)^t);
      dvdx1=-(1-x(2)^t);
      dvdx2=t*x(1)*x(2)^(t-1);
      dvdx1dx1=0;
      dvdx1dx2=t*x(2)^(t-1);
      dvdx2dx2=(t-1)*t*x(1)*x(2)^(t-2);
      dvdx2dx1=t*x(2)^(t-1);
      h=h+[2*v*dvdx1dx1+2*dvdx1^2, 2*v*dvdx1dx2+2*dvdx1*dvdx2;
           2*v*dvdx2dx1+2*dvdx2*dvdx1, 2*v*dvdx2dx2+2*dvdx2^2];
  end
end
