function [reldif,mxdiff,mxdifx]=hesstest(fcn,hsn,xl,xh,ii)
% compare analytic to finite-difference Hessian for function ii

  n=size(xh,1);                    % number of variables
  x=zeros(n,1);                    % x is a column
  mxdiff=0;                        % no maximum difference yet
  mxdifx=x;                        % if none return origin
  for k=1:100                      % try 100 points in [xl,xh]
      for j=1:n                            % with
          x(j)=xl(j)+rand()*(xh(j)-xl(j)); % random
      end                                  % components

    ha=hsn(x,ii);                  % analytic Hessian
    hf=hesscd(fcn,x,ii);           % finite difference Hessian
    for i=1:n                      % compare
    for j=1:n                      % each element
        diff=abs(ha(i,j)-hf(i,j)); % difference between elements
        if(diff > mxdiff)          % keep track of the
           mxdiff=diff;            % biggest difference
           mxdifx=x;               % and where it occurred
        end                        % done with comparison
    end                            % done
    end                            % with elements
  end                              % done with trial points

  nrm=norm(hesscd(fcn,mxdifx,ii)); % size of approximate Hessian
  if(nrm < 1e-6)                   % if it is tiny
     reldif=-1;                    % relative error is meaningless
  else                             % norm is not tiny
     reldif=mxdiff/nrm;            % relative error is usefull
  end

end
