function [U,rc,nm]=hfact(H,gama)
% factor H, modifying it if necessary

  nm=0;                        % prepare to count modifications
  [U,pz]=chol(H);              % try to factor H
  if(pz~=0)                    % is it positive definite?
    if(gama >= 1 || gama < 0)  % no; is modification possible?
       rc=1;                   % no; gama value prevents that
       return                  % resign
    end                        % yes; modification possible
    n=size(H,1);               % find number of variables
    tmax=1022;                 % limit modifications
    for t=1:tmax               % repeat until limit or success
      H=gama*H+(1-gama)*eye(n);  % average with identity
      nm=nm+1;                   % count the modification
      [U,pt]=chol(H);            % try again to factor
      if(pt==0) break; end       % positive definite now?
    end                        % no; continue modifications
    if(pt~=0)                  % was modification successful?
      rc=2;                    % no; factorization still fails
      return                   % resign
    end                        % yes; modification succeeded
  end                          % factorization complete
  rc=0;                        % signal success

end
