function [xt,yt]=hplane(del,a,p,b)
% return in xt and yt the endpoints of a line segment
% that is part of the hyperplane del'x=del'p 
% and goes from a units on one side of p to b units on the other

  xt=zeros(2,1); yt=zeros(2,1);           % xt and yt are columns
  g=del/norm(del);                        % unit normal to H
  if(g(1) == 0 && g(2) == 0) return; end  % if zero give up

  if(g(1) == 0)          % if gradient is vertical
     yt(1)=p(2);         % draw
     xt(1)=p(1)-a;       % a
     yt(2)=p(2);         % horizontal
     xt(2)=p(1)+b;       % line
     return
  end
  if(g(2) == 0)          % if gradient is horizontal
     xt(1)=p(1);         % draw
     yt(1)=p(2)-a;       % a
     xt(2)=p(1);         % vertical
     yt(2)=p(2)+b;       % line
     return
  end

  xt(1)=p(1)-a*g(2);     % gradient is slanted
  yt(1)=p(2)+a*g(1);     % draw a line
  xt(2)=p(1)+b*g(2);     % orthogonal to
  yt(2)=p(2)-b*g(1);     % the gradient

end
