% ill.m: monitor the penalty algorithm solution of p2
clear;clf
format long

global prob='p2' m=1 mu=0                    % specify the problem
xzero=[1;2];                                 % starting point
mu=0.05;                                     % starting multiplier
for k=1:59                                   % do the sequence 
    xpi=ntrs(xzero,0,1029,1e-16,@pye,@pyeg,@pyeh,0.5); % solve
    mus(k)=mu;                               % remember the multiplier
    g(k)=norm(pyeg(xpi));                    % remember the gradient
    H=pyeh(xpi);                             % get the Hessian of pi
    kpa(k)=cond(H);                          % and remember its condition
    if(k==58)                                % at this iteration
       x58=xpi;                                % save the current point
       mu58=mu;                                % and the current multiplier
    end                                      % for study later
    xzero=xpi;                               % restart from the solution
    mu=2*mu;                                 % with higher multiplier
end                                          % end of sequence

figure(1); set(gca,'FontSize',25)            % separate the picture
hold on                                      % start the picture
axis([1e-2,1e17,1e-17,1e1])                  % set axes
loglog(mus,g)                                % plot norm(g) vs mu
plot([1e-2,1e17],[1e-16,1e-16])              % draw a line at 1e-16
hold off                                     % end the picture
print -deps -solid illg.eps                  % and print it
figure(2); set(gca,'FontSize',25)            % separate the picture
hold on                                      % start the picture
axis([1e-2,1e17,1e0,1e17])                   % set axes
loglog(mus,kpa)                              % plot kappa(H) vs mu
hold off                                     % end the picture
print -deps -solid illk.eps                  % and print it

mu=mu58;          % this was the multiplier just before the end
x58               % this was the iterate
f58=pye(x58)      % get the penalty function value there
g58=pyeg(x58)     % and the gradient
H58=pyeh(x58)     % and the Hessian
d=-inv(H58)*g58   % find the Newton descent direction
x59=x58+d         % take a full step in that direction
f59=pye(x59)      % and find the penalty function value there
