function [xstar,ystar]=lpin(A,b,c,xzero,yzero)
% minimize c'x subject to Ax=b and x nonnegative
% by a primal-dual interior point algorithm

  x=xzero;
  y=yzero;
  s=c-A'*yzero;
  epz=1e-9;
  mu=1;
  n=size(xzero,1);
  for k=1:52
      X=diag(x);
      S=diag(s);
      D=inv(S)*X;
      v=mu*ones(n,1)-X*S*ones(n,1);
      dy=-inv(A*D*A')*A*inv(S)*v;
      ds=-A'*dy;
      dx=inv(S)*v-D*ds;
      if(norm(dy)<epz && norm(ds)<epz && norm(dx)<epz) break; end
      alpha=1;
      for j=1:n
          if(dx(j) < 0) alpha=min(alpha,0.99999*(-x(j)/dx(j))); end
          if(ds(j) < 0) alpha=min(alpha,0.99999*(-s(j)/ds(j))); end
      end
      y=y+alpha*dy;
      s=s+alpha*ds;
      x=x+alpha*dx;
      mu=mu/2;
  end
  xstar=x;
  ystar=y;

end
