function ip=minr(T,tr,mr,jp);
% find the minimum ratio row ip in pivot column jp of T

  ztol=1.e-6;                     % zero tolerance
  ip=0;                           % return index zero on failure
  rmin=realmax;                   % rmin = +infinity

  for ii=2:mr                     % check each constraint row
      if(T(tr(ii),jp) <= ztol)    % is this pivot negative or too small?
         continue                 % yes; skip it
      end                         % and continue down the column
      r=T(tr(ii),1)/T(tr(ii),jp); % find this row ratio
      if(r < rmin)                % is it lower than best so far?
         rmin=r;                  % yes; update best so far
         ip=tr(ii);               % and the row where it happens
      end                         % and continue
  end                             % until all rows are checked
end
