% mismatch.m: study how q(x) departs from f(x) in taking first step
clear; clf; set(gca,'FontSize',30)

x0=[1;0.6];            % starting point
x1=[8.8686;-1.5310];   % first iterate produced by ntfs.m
d=x1-x0;               % full Newton step (nm was zero)
for t=1:101            % at each of 101 points
    s(t)=0.012*(t-1);  % along that direction
    x=x0+s(t)*d;       % find x
                       % evaluate the objective and model
    f(t)=h35(x);      
    q(t)=h35(x0)+h35g(x0)'*(x-x0)+0.5*(x-x0)'*h35h(x0)*(x-x0);
end

figure(1); set(gca,'FontSize',30)
hold on
axis([0,1.2,-30,10],'square')
plot(s,f)              % plot objective on a linear scale
plot(s,q)              % plot quadratic on a linear scale
hold off
print -deps -solid mislin.eps

figure(2); set(gca,'FontSize',30)
hold on               
axis([0,1.2],'square')
semilogy(s,f)          % plot objective on a log scale
hold off
print -deps -solid mislog.eps
