function [Tnew,S,trnew,mrnew,rc0]=newseq(T,mm,nn,tr,mr)
%  get the identity columns with zero costs above

   ztol=1e-6;       % set zero tolerance
   rc0=0;           % assume this routine will succeed
   for j=2:nn       % start
       S(j-1)=0;    % with
   end              % no basis
   ir=1;            % point to the objective row

   while(ir < mr)   % are any constraint rows left to consider?
     ir=ir+1;       % yes; advance to the next one
     ip=tr(ir);                     % in row ip
       jp=0;                        % find
       for jj=2:nn                  % the first
           if(abs(T(ip,jj)) > ztol) % nonzero entry
              jp=jj;                % at column jp
              break                 % and use it
           end                      % if not yet
       end                          % keep looking

       if(jp > 0)                   % if we found a nonzero entry
          [Tnew,Snew,rc]=pivot(T,mm,nn,ip,jp,S); % pivot on it
          T=Tnew;                   % update the tableau
          S=Snew;                   % and the basic sequence
          continue                  % go to do the next row
       end                          % otherwise fall through

       if(abs(T(ip,1)) <= ztol)     % A row is zero; check the b
          for iir=ir:mr-1           % this tableau row is redundant
              tr(iir)=tr(iir+1);    % copy the row pointers up
          end                       % to squeeze out redundant row
          tr(mr)=0;                 % zero last pointer now repeated
          mr=mr-1;                  % one less row in the problem
          ir=ir-1;                  % account for the deletion
       else         % we have discovered infeasible form 1
          rc0=1;    % set the return code to indicate that
          break     % and return
       end          % finished processing the zero A row 
   end              % finished with constraint rows in the problem

   trnew=tr;        % return updated list of active rows
   mrnew=mr;        % and updated number of active rows
end
