function [xstar,k]=nlpin(xzero,m,epz,fcn,grd,hsn)
% solve a standard-form nonlinear program by a primal-dual interior point algorithm

  n=size(xzero,1);
  v=ones(n+2*m,1);
  v(1:n)=xzero;
  mu=1;
  for k=1:52
      Jpx=hsn(v(1:n),0);
        for i=1:m
            Jpx=Jpx+v(n+m+i)*hsn(v(1:n),i);
        end
      Jps=zeros(n,m);
      for i=1:m
          Jplambda(:,i)=grd(v(1:n),i);
      end
      Jcx=zeros(m,n);
      Jcs=zeros(m,m);
        for i=1:m
            Jcs(i,i)=v(n+m+i);
        end
      Jclambda=zeros(m,m);
        for i=1:m
            Jclambda(i,i)=v(n+i);
        end
      Jdx=Jplambda';
      Jds=eye(m,m);
      Jdlambda=zeros(m,m);
      J=[Jpx,Jps,Jplambda;Jcx,Jcs,Jclambda;Jdx,Jds,Jdlambda];

      F=zeros(2*m+n,1);
      F(1:n)=grd(v(1:n),0);
        for i=1:m
            F(1:n)=F(1:n)+v(n+m+i)*grd(v(1:n),i);
        end 
      F(n+1:n+m)=-mu*ones(m,1);
        for i=1:m
            F(n+i)=F(n+i)+v(n+i)*v(n+m+i);
        end
      for i=1:m
        F(n+m+i)=fcn(v(1:n),i)+v(n+i);
      end

      d=inv(J)*(-F);
      alpha=1;
      for j=n+1:n+2*m
          if(d(j) < 0) alpha=min(alpha,0.99999*(-v(j)/d(j))); end
      end
      v=v+alpha*d;

      if(norm(d) <= epz) break; end
      mu=mu/2;
  end
  xstar=v(1:n);

end
