function [xstar,k]=nlpinp(xzero,m,epz,fcn,grd,hsn)
% minimize f0(x) subject to fi(x)<=0 for i=1..m by a primal interior point algorithm

  x=xzero;
  mu=1;
  for k=1:52
      F=grd(x,0);
      for i=1:m
          F=F-mu*(grd(x,i)/fcn(x,i));
      end
      J=hsn(x,0);
      for i=1:m
          J=J-mu*(fcn(x,i)*hsn(x,i)-grd(x,i)*grd(x,i)')/(fcn(x,i)^2);
      end
      d=inv(J)*(-F);
      if(norm(d) <= epz) break; end
      alpha=1;
      for t=1:52
          ok=true;
          for i=1:m
              if(fcn(x+alpha*d,i) < 0) continue; end
              ok=false;
              break
          end
          if(ok) break; end
          alpha=alpha/2;
      end
      x=x+alpha*d;
      mu=mu/2;
  end
  xstar=x;

end
