% ntdeltas.m: compare deltas found two ways
  mu=0.5;
  n=4;
  m=2;
  A=[-1,1,1,0;1,0,0,1];
  b=[1;1];
  c=[1;1;0;0];
  x=[0.5;0.5;1;0.5];
  y=[-0.5;-0.5];
  s=[1;1.5;0.5;0.5];
  X=diag(x);
  S=diag(s);
  D=inv(S)*X;

% use the boxed formulas of Section 21.1.2
  v=mu*ones(n,1)-X*S*ones(n,1);
  dy=-inv(A*D*A')*A*inv(S)*v;
  ds=-A'*dy;
  dx=inv(S)*v-D*ds;
  printf('%8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f\n',dx,dy,ds) 

% use the general form of Newton's method for systems
  J=zeros(2*n+m,2*n+m);
  J(1:m,1:n)=A;
  J(m+1:m+n,n+1:n+m)=A';
  J(m+1:m+n,n+m+1:2*n+m)=eye(n,n);
  J(m+n+1:2*n+m,1:n)=S;
  J(m+n+1:2*n+m,n+m+1:2*n+m)=X;
  fp=A*x-b;
  fd=A'*y+s-c;
  fc=S*X*ones(n,1)-mu*ones(n,1);
  F=[fp;fd;fc];
  du=inv(J)*(-F);
  printf('%8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f %8.5f\n',du) 
