% p2nonpd.m: study the nonconvexity of the p2 problem 
clear;clf

global prob='p2' m=1 mu=0                    % specify the problem
xl=[0;0]; xh=[3;3];                          % bounds for plots
xstar=[0.945582993415968;0.894127197437503]; % optimal point of p2
vc=[40,25,14,7,5,pye(xstar),1,.25,.05];      % fix contour levels
mus=[0,4,16,1000];                           % multiplier values

for t=1:4                                    % consider 4 cases
    mu=mus(t);                               % set multiplier value
    figure(t); set(gca,'FontSize',20)        % separate pictures
    axis([xl(1),xh(1),xl(2),xh(2)],'square') % scale graph axes
    hold on                                  % start plot
    [xc,yc,zc]=gridcntr(@pye,xl,xh,200);     % grid penalty function
    contour(xc,yc,zc,vc)                     % plot penalty contours
    plotpd(xl,xh,20,@pyeh)                   % plot pd points
    plot(1,2,'o')                            % plot starting point
    plot(xstar(1),xstar(2),'o')              % plot optimal point
    hold off                                 % done with plot
    switch(t)                                % print the picture
      case 1; print -deps p2nonpd1.eps       % mu=1
      case 2; print -deps p2nonpd2.eps       % mu=8
      case 3; print -deps p2nonpd3.eps       % mu=16
      case 4; print -deps p2nonpd4.eps       % mu=1000
    end                                      % done printing
end                                          % done with cases
