function [Tnew,Snew,rc1]=phase1(T,S,mm,nn,tr,mr)
% get constant column nonnegative, or find problem infeasible

  ztol=1e-6;                       % set zero tolerance
  Tnew=T;                          % return T on failure
  Snew=S;                          % return S on failure

  ii=0;                            % assume every b is negative
  for ir=2:mr                      % search the constant column
      ic=tr(ir);                   % constraint rows in the problem
      if(T(ic,1) >= 0)             % is this b nonnegative?
         ii=ic;                    % yes; remember the tableau row
         break                     % we found one
      end                          % so stop
  end                              % searching

  if(ii == 0)                      % every b is negative
     jp=0;                         % search
     for jj=2:nn                   % the first A row
         if(T(tr(2),jj) < 0)       % for a negative entry
            jp=jj;                 % and remember where it was
            break                  % found one
         end                       % finished testing
     end                           % finished searching row
     if(jp == 0)                   % if no A row entry is negative
        rc1=2;                     % signal infeasible form 2
        return                     % and give up
     else                                         % otherwise
        [Tnew,Snew,rc]=pivot(T,mm,nn,tr(2),jp,S); % pivot there
        T=Tnew;                                   % update T
        S=Snew;                    % update S
     end                           % pivot made b1 nonnegative
  end                              % now ready for subproblems

  for p=1:mm-1                     % need no more than m subprobs
      ms=1;                        % construct the next subproblem
      sr(ms)=0;                    % row ms is to be selected
      for ir=2:mr                  % search constraint rows
          ii=tr(ir);               % that are in the problem
          if(T(ii,1) < 0)          % for a negative b
             if(sr(1) == 0)        % if it is the first
                sr(1)=ii;          % make it the subprob obj
             end;                  % finished making subprob obj
          else                     % this b is nonnegative
             ms=ms+1;              % enlarge the subproblem
             sr(ms)=ii;            % and add this row to it
          end                      % done testing this row
      end                          % done constructing subproblem
      if(sr(1) == 0)               % if no subproblem objective
         rc1=0;                    % signal canonical form
         return                    % and return
      end                          % done testing completion

      [Tnew,Snew,rc2]=phase2(T,S,mm,nn,sr,ms); % solve subproblem
      T=Tnew;                                  % update T
      S=Snew;                      % update S
      if(abs(T(sr(1),1)) < ztol)   % if final b is tiny 
         T(sr(1),1)=0;             % make it zero exactly
      end                          % finished checking b

      if(rc2 == 0 && T(sr(1),1) < 0) % if final b is negative
         rc1=2;                      % mark infeasible form 2
         return                    % and give up
      end                          % finished with infeasible

      if(rc2 > 0 && T(sr(1),1) < 0) % if subproblem unbounded
         jp=rc2;                    % pivot in unbounded column
         ip=sr(1);                              % in objective
         [Tnew,Snew,rc]=pivot(T,mm,nn,ip,jp,S); % do the pivot
         T=Tnew;                                % update T
         S=Snew;                   % update S
      end                          % finished with unbounded
  end                              % finished with subproblems
  rc1=0;                           % signal success
end
