function [Tnew,Snew,rc]=pivot(T,mm,nn,ip,jp,S)
%  perform a pivot at T(ip,jp)
%
   if(T(ip,jp) == 0)                  % check for a zero pivot
      rc=1;                           % signal the error
      return                          % and give up
    end                               % finished checking

   for ii=1:mm                        % update tableau rows
       if(ii == ip) continue; end     % except for pivot row
       for jj=1:nn                    % update non-pivot columns
           if(jj == jp) continue; end
           Tnew(ii,jj)=T(ii,jj)-T(ip,jj)*T(ii,jp)/T(ip,jp);
       end
   end                                % advance to the next row

   for jj=1:nn                        % update pivot row
       if(jj == jp) continue; end     % except for pivot column
       Tnew(ip,jj)=T(ip,jj)/T(ip,jp); % divide by the pivot element
   end                                % advance to next column

   for ii=1:mm                        % update pivot column
       if(ii == ip)                   % making the pivot element
          Tnew(ii,jp)=1;              % exactly 1
       else                           % and the other elements
          Tnew(ii,jp)=0;              % exactly 0
       end                            % finished testing
   end                                % finished with the column

   for jj=2:nn                        % update the basis
       if(S(jj-1) == ip)              % mark outgoing column
          Snew(jj-1)=0;               % nonbasic
       else                           % while keeping
          Snew(jj-1)=S(jj-1);         % the other columns unchanged
       end                            % finished testing
   end                                % finished removing outgoing
   Snew(jp-1)=ip;                     % mark incoming column basic

   rc=0;                              % signal success
end                                   % and return to the caller
