function [xstar,kp,rc]=plrb(xzero,xl,xh,kmax,epz,fcn,grd)
% Polak-Ribiere algorithm
  n=size(xzero,1);
  xk=xzero;
  gk=grd(xk);
  d=-gk;
  mu=0.0001;
  eta=0.4;
  smax=52;
  for kp=1:kmax
      if(norm(gk) <= epz)
         xstar=xk;
         rc=0;
         return
      end
      tol=1000*epz*norm(gk);
      [astar,rcw,kw]=wolfe(xk,d,xl,xh,n,fcn,grd,mu,eta,tol,smax);
      if(rcw > 2) break; end
      xk=xk+astar*d;
      gkp=grd(xk);
      beta=max(0,(gkp'*(gkp-gk))/(gk'*gk));
      d=-gkp+beta*d;
      gk=gkp;
  end
  xstar=xk;
  rc=1;
end
