% prs.m: solve the rb problem by pure random search
clear; clf; set(gca,'FontSize',30)
format long

xl=[-2;-1];                              % lower left corner of box
xh=[ 2; 2];                              % upper right corner of box

xzero=[-1.2;1];                          % starting point
xstar=[1;1];                             % optimal point
ezero=norm(xzero-xstar);                 % error at starting point

fr=+realmax;                             % record value = +infinity
xk=xzero;                                % current iterate = starting point
for k=1:1000000                          % try a million points
    fk=rb(xk);                           % objective at current point
    if(fk < fr)                          % better than record value?
        fr=fk;                           % yes; remember it
        xr=xk;                           % and where it happened
    end
    xerr(k)=norm(xr-xstar)/ezero;        % remember error at record point
    it(k)=k;                             % remember current iteration
    u=rand(2,1);                         % random vector uniform on (0,1)
    for j=1:2                            % in each coordinate direction
        xk(j)=xl(j)+u(j)*(xh(j)-xl(j));  % find value between bounds
    end
end

xr                                       % report best point found
fr                                       % report the objective there
xerrend=xerr(1000000)                    % report final relative error
loglog(it,xerr)                          % plot log error versus log k
print -deps -solid prs.eps               % print the plot
