function [xstar,kp]=qeplain(Q,c,A,xzero,kmax,epz)
% solve an equality-constrained quadratic program
  Z=null(A);
  Hinv=Z*(inv(Z'*Q*Z))*Z';
  xk=xzero;
  for kp=1:kmax
%     find the full Newton step on the flat
      d=-Hinv*(Q*xk+c);

%     take the step
      xk=xk+d;

%     test for convergence
      if(norm(d) <= epz) break; end
  end
  xstar=xk;
end
