%rbntfs.m: study the solution of rb using modified Newton descent
clear; clf; set(gca,'FontSize',20)
xl=[-2;-1];                                   % catalog lower bounds
xh=[2;2];                                     % catalog upper bounds
axis([xl(1),xh(1),xl(2),xh(2)],'equal')       % set graph axes
hold on                                       % start the graph
[xc,yc,zc,zmin,zmax]=gridcntr(@rb,xl,xh,200); % grid the objective
vc=[0.1,1,4];                                 % set contour levels
contour(xc,yc,zc,vc)                          % draw the contours

for p=1:100                                   % find 100 points on
    x(p)=xl(1)+(xh(1)-xl(1))*((p-1)/99);      % the curve x2=x1^2+1/200
    y(p)=x(p)^2+0.005;                        % where the Hessian
end                                           % is singular
plot(x,y,'o')                                 % and plot them
plotpd(xl,xh,20,@rbh)                         % show where H is pd

yks=[-0.5,+0.5];                              % define two starting points
for L=1:2                                     % for each
    xk=[0;yks(L)];                            % start there
    for k=1:10                                        % do up to 10 iterations
        [xkp,kp,nm,rc]=ntfs(xk,1,1e-6,@rbg,@rbh,0.5); % of modifed Newton
        xt(k)=xk(1);                                  % capture
        yt(k)=xk(2);                          % the iterate
        if(rc == 0) break; end                % quit if tolerance met
        xk=xkp;                               % otherwise update iterate
    end                                       % and continue
    plot(xt,yt)                               % plot convergence trajectory
end
hold off
print -deps -solid rbntfs.eps
