% ridge.m: plot the ridge trace
clear; clf; set(gca,'FontSize',25)

load -ascii snowind.dat           % read David's new data
n=size(snowind,1);                % find out how many data points
X=[ones(n,1),snowind(:,1:2)];     % construct the X matrix
Y=snowind(:,3);                   % construct the Y vector

Ibar=eye(3);                      % construct the identity
Ibar(1,1)=0;                      % zero the upper left element

for p=1:51                        % consider 51 values of lambda
    lambda(p)=0.001*(p-1);        % going from 0 to 0.05
    U=chol(X'*X+lambda(p)*Ibar);  % matrix factorization
    z=U'\(X'*Y);                  % forward substitution to find z
    bta=U\z;                      % back substitution to find bta
    b0(p)=bta(1);                 % capture the
    b1(p)=bta(2);                 % coefficient estimates
    b2(p)=bta(3);                 % to plot later
end

hold on                           % prepare to plot 3 curves
axis([0,0.05,-25,60])             % set graph axes
plot(lambda,b0)                   % plot the
plot(lambda,b1)                   % coefficient estimates
plot(lambda,b2)                   % saved earlier
hold off
print -deps -solid ridge.eps      % print the graph
