% rneqplot.m: plot convergence trajectory of rneq.m solving rnt
clear; clf; set(gca,'FontSize',20)

A=[3,-1,-2,-1;-4,1,5,2];
b=[-1;3];
xbar=[-2;-5;0;0];
Z=null(A);
for kmax=0:34
    [xstar,k,rc,nm]=rneq(@rntg,@rnth,A,b,kmax,1e-6);
    t=Z'*(xstar-xbar);
    t1(kmax+1)=t(1);
    t2(kmax+1)=t(2);
end

tl=[-1;-1];
th=[ 8; 3];
ng=50;
for i=1:ng;
    t1i(i)=tl(1)+(th(1)-tl(1))*((i-1)/(ng-1));
    for j=1:ng;
        t2i(j)=tl(2)+(th(2)-tl(2))*((j-1)/(ng-1));
        t=[t1i(i);t2i(j)];
        x=Z*t+xbar;
        zi(j,i)=rnt(x);
    end
end
v=[0.1,1,2,4,8];

hold on
axis([tl(1),th(1),tl(2),th(2)],'equal')
contour(t1i,t2i,zi,v)
plot(t1,t2)
plot(t1,t2,'o')
hold off
print -deps -solid rneq.eps
