% sdconv.m: plot error in gns solution by steepest descent
clear; clf; set(gca,'FontSize',30)

xzero=[2;2];
xstar=[0.75;-0.75];
epz=1e-15;

% generate the iterates and compute the errors
x=xzero;
for k=1:20
    x=sdfs(x,1,epz,@gnsg,@gnsh);
    error(k)=norm(x-xstar)/norm(xzero-xstar);
    iters(k)=k;
end

% plot log error versus iterations
hold on
semilogy(iters,error,'o')
semilogy([0,20],[1,error(20)])
hold off
print -deps -solid sdconv.eps
c=10^(log10(error(20))/20)
