% second.m: approximate f'' for f(x)=exp(x)
clear;clf;set(gca,'FontSize',25)
delta=1.25;
for i=1:100
    delta=0.8*delta;
    deltai(i)=delta;
    d2yfe=0;
    d2yce=0;

%   second derivative of e^x
    for j=1:101
        x=.01*(j-1);
        y=exp(x);
        xpd=x+delta;
        ypd=exp(xpd);
        xp2d=x+2*delta;
        yp2d=exp(xp2d);
        xmd=x-delta;
        ymd=exp(xmd);
        xm2d=x-2*delta;
        ym2d=exp(xm2d);

%       forward differencing
        d2yf=(yp2d-2*ypd+y)/delta^2;
        d2yfe=d2yfe+(d2yf-exp(x))^2;

%       central differencing
        d2yc=(yp2d-2*y+ym2d)/(2*delta)^2;
        d2yce=d2yce+(d2yc-exp(x))^2;
    end

%   find the norm of each set of errors
    nd2yfe(i)=sqrt(d2yfe);
    nd2yce(i)=sqrt(d2yce);
end

% plot the errors
hold on
axis('square')
loglog(deltai,nd2yfe)
loglog(deltai,nd2yce)
hold off
print -deps -solid second.eps
