function [xstar,rc,Tnew]=simplex(T,m,n)
%  solve a linear program in standard form

   nn=n+1;        % tableau columns = variables+1
   mm=m+1;        % tableau rows = constraints+1
   for ii=1:mm    % to start include them all
       tr(ii)=ii; % in the list of rows
   end            % that are in the problem
   mr=mm;         % there are mr of those

   [Tnew,S,trnew,mrnew,rc0]=newseq(T,mm,nn,tr,mr); % get identity
   if(rc0 != 0)   % on failure
      rc=1;       % report infeasible
      return      % and give up
   else           % otherwise
      T=Tnew;     % update the tableau
   end            % and continue

   [Tnew,Snew,rc1]=phase1(T,S,mm,nn,tr,mr); % get b nonnegative
   if(rc1 != 0)   % on failure
      rc=1;       % report infeasible
      return      % and give up
   else           % otherwise
      T=Tnew;     % update the tableau
      S=Snew;     % update the basic sequence
   end            % and continue

   [Tnew,Snew,rc2]=phase2(T,S,mm,nn,tr,mr); % get c nonnegative
   if(rc2 != 0)               % on failure
      rc=rc2;                 % report unbounded form in column rc
      return                  % and give up
   else                       % otherwise
      rc=0;                   % report optimal form
      for j=1:n               % for each j
          ii=Snew(j);         % find the row of the basic column 1
          if(ii == 0)         % if this column is nonbasic
             xstar(j)=0;      % return zero
          else                    % otherwise
             xstar(j)=Tnew(ii,1); % return the basic variable value
          end                     % finished retrieving this variable
      end                     % finished constructing x* vector
   end                        % end of simplex algorithm
end
