function ip=smind(T,tr,mr,jp,nn,S)
% find the pivot row using the smallest-leaving-index rule

  ztol=1e-6;
  flag=ones(1,mr-1);

% find the row ratios and their minimum
  rmin=realmax;
  ip=0;
  for i=1:mr-1
      if(T(tr(i+1),jp) <= ztol)
         flag(i)=0;
         continue
      end
      r(i)=T(tr(i+1),1)/T(tr(i+1),jp);
      if(r(i) < rmin)
         rmin=r(i);
         ip=tr(i+1);
      end
  end

% rule out non-min-ratio rows and count min-ratio ties
  tied=0;
  for i=1:mr-1
      if(flag(i) == 0) continue; end
      if(abs(r(i)-rmin) > ztol)
         flag(i)=0;
      else
         tied=tied+1;
      end
  end

% accept the minimum ratio row if it is unique
  if(tied == 1) return; end

% among min ratio rows pick the one whose 1 has lowest col index
  idxmin=nn;
  for i=1:mr-1
      if(flag(i) == 0) continue; end
      for jj=2:nn
          if(S(jj-1) == i+1)
            idx=jj-1;
            break
          end
      end
      if(idx < idxmin)
         idxmin=idx;
         ip=tr(i+1);
      end
  end

end
