function flag=socheck(m,x,lambda,grd,hsn)
% classify a Lagrange point (x,lambda)
% by examining the eigenvalues
% of the projected Hessian of the Lagrangian

  HL=hsn(x,0);                   % Hessian of objective
  for i=1:m                      % add in the sum of multiplier
      HL=HL+lambda(i)*hsn(x,i);  % times Hessian of constraint
  end                            % to get Hessian of Lagrangian

  for i=1:m                      % construct the matrix
      g=grd(x,i);                % whose rows are
      A(i,:)=g';                 % the constraint gradients
  end                            % so that Ax=0 on T
  Z=null(A);                     % get a basis for the nullspace
  Hbar=Z'*HL*Z;                  % use it to project HL onto T

  flag=+1;                       % assume Hbar will be pd
  ev=eig(Hbar);                  % find the eigenvalues of Hbar
  n=size(x,1);                   % number of variables
  for p=1:n-m                    % check all eigenvalues of Hbar
      if(abs(ev(p)) < 1e-8)      % if small assume zero
        flag=0;                  % which makes Hbar psd
        continue                 % and check the next eigenvalue
      end                        % done checking for Hbar psd
      if(ev(p) < 1e-8)           % if negative
        flag=-1;                 % that makes Hbar not psd
        break                    % no further checking is needed
      end                        % done checking for Hbar not psd
  end                            % done checking eigenvalues

end
