function ip=srr(T,tr,mr,jp,nn)
% find the pivot row using the successive-ratio rule

  ztol=1e-6;
  flag=ones(1,mr-1);

% use successive columns to form the row ratios
  for jr=1:nn

%     find the row ratios and their minimum
      rmin=realmax;
      ip=0;
      for i=1:mr-1
          if(flag(i) == 0) continue; end
          if(T(tr(i+1),jp) <= ztol)
             flag(i)=0;
             continue
          end
          r(i)=T(tr(i+1),jr)/T(tr(i+1),jp);
          if(r(i) < rmin)
             rmin=r(i);
             ip=tr(i+1);
          end
      end

%     rule out non-min-ratio rows and count ties
      tied=0;
      for i=1:mr-1
          if(flag(i) == 0) continue; end
          if(abs(r(i)-rmin) > ztol)
             flag(i)=0;
          else
             tied=tied+1;
          end
      end

%     accept the minimum ratio row if it is unique
      if(tied == 1) return; end
  end
end
